#include <windows.h>
#include <commctrl.h>
#include "wrapi.h"

#define IDC_ATTEN	1004
#define IDC_MUTE	1005
#define IDC_POWER	1006
#define IDC_QUIT	1007
#define IDC_VOLUMEEDIT 1001
#define IDC_VOLUME  1100
#define IDC_BFOEDIT 1010
#define IDC_BFO		1200
#define IDC_FREQEDIT	1011
#define IDC_PROGRESSBAR 1002
#define IDC_MODE	1000

#define IDC_MODELABEL	1012
#define IDC_ATTENLABEL  1013
#define IDC_MUTELABEL	1014
#define IDC_POWERLABEL	1015
#define IDC_HEADINGLABEL 1016

HINSTANCE hInst;
int hRadio;
BOOL Atten;
BOOL Mute;
BOOL Power;
int Volume;
int BFOOffset;
long Frequency;
int ModeIndex;
long SignalStrength;

HFONT Font;

RADIOINFO RadioInfo;

BOOL CALLBACK SetFontFunc(HWND hwnd, LPARAM lParam)
{
	SendMessage(hwnd, WM_SETFONT, lParam, 0);
	
	return TRUE;
}

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HWND hEdit;
	char ModeString[32];
	int Mode;
	int	Vol;
	LOGFONT lf;
	HDC dc;
	
	switch (uMsg) 
	{
		case WM_CREATE:	

			// set fonts
			memset(&lf, 0, sizeof(lf));
			dc = GetDC(0);
			lf.lfHeight = -8 * GetDeviceCaps(dc, LOGPIXELSY) / 72;
			lf.lfWeight = FW_NORMAL;
			strcpy(lf.lfFaceName, "MS Sans Serif");
			Font = CreateFontIndirect(&lf);

			// initialise controls from WiNRADiO card

			// initialise Volume UpDown control/ Label
			Vol = GetVolume(hRadio);


			// place the controls
		  	CreateWindowEx(0, "BUTTON", "&Mode", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 
				176, 32, 49, 25, hwnd, (HMENU)IDC_MODE, hInst, 0);
			CreateWindowEx(0, "BUTTON", "&Atten", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 
				176, 64, 49, 25, hwnd, (HMENU)IDC_ATTEN, hInst, 0); 
			CreateWindowEx(0, "BUTTON", "M&ute", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 
				176, 96, 49, 25, hwnd, (HMENU)IDC_MUTE, hInst, 0);
			CreateWindowEx(0, "BUTTON", "&Power", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 
				176, 128, 49, 25, hwnd, (HMENU)IDC_POWER, hInst, 0);
			CreateWindowEx(0, "BUTTON", "&Quit", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 
				16, 128, 49, 25, hwnd, (HMENU)IDC_QUIT, hInst, 0); 
			CreateWindowEx(0, "STATIC", "WiNRADiO C++ API Demonstration", WS_CHILD | WS_VISIBLE | SS_LEFT, 
				70, 8, 300, 20, hwnd, (HMENU)IDC_HEADINGLABEL, hInst, 0); 
			CreateWindowEx(0, "STATIC", "Frequency:", WS_CHILD | WS_VISIBLE | SS_LEFT, 
				16, 32, 70, 20, hwnd, (HMENU)-1, hInst, 0);
			CreateWindowEx(0, "STATIC", "BFO Adjust", WS_CHILD | WS_VISIBLE | SS_LEFT, 
				16, 64, 70, 20, hwnd, (HMENU)-1, hInst, 0);
			CreateWindowEx(0, "STATIC", "Vol Adjust", WS_CHILD | WS_VISIBLE | SS_LEFT, 
				16, 96, 80, 20, hwnd, (HMENU)-1, hInst, 0);
			CreateWindowEx(0, "STATIC", "Signal Level", WS_CHILD | WS_VISIBLE | SS_LEFT, 
				96, 120, 80, 20, hwnd, (HMENU)-1, hInst, 0);
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_READONLY,
				80, 96, 80, 20, hwnd, (HMENU)IDC_VOLUMEEDIT, hInst, 0);
			CreateUpDownControl(WS_CHILD | WS_VISIBLE | UDS_AUTOBUDDY | UDS_ALIGNRIGHT | UDS_ARROWKEYS | UDS_SETBUDDYINT, 
				200, 10, 15, 20, hwnd, IDC_VOLUME, hInst, hEdit, 31, 0, 0);
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				80, 64, 81, 21, hwnd, (HMENU)IDC_BFOEDIT, hInst, 0);
			CreateUpDownControl(WS_CHILD | WS_VISIBLE | UDS_AUTOBUDDY | UDS_ALIGNRIGHT | UDS_ARROWKEYS | UDS_SETBUDDYINT | UDS_NOTHOUSANDS, 
				200, 10, 15, 20, hwnd, IDC_BFO, hInst, hEdit, 3000, -3000, 0);
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | 0x2000,
				80, 32, 81, 21, hwnd, (HMENU)IDC_FREQEDIT, hInst, 0);
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_READONLY,
				233, 36, 32, 17, hwnd, (HMENU)IDC_MODELABEL, hInst, 0);
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_READONLY,
				233, 68, 32, 17, hwnd, (HMENU)IDC_ATTENLABEL, hInst, 0);
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_READONLY,
				233, 100, 32, 17, hwnd, (HMENU)IDC_MUTELABEL, hInst, 0);
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_READONLY,
				233, 132, 32, 17, hwnd, (HMENU)IDC_POWERLABEL, hInst, 0);

			CreateWindowEx(0, PROGRESS_CLASS, "", WS_CHILD | WS_VISIBLE, 
				80, 136, 81, 17, hwnd, (HMENU)IDC_PROGRESSBAR, hInst, 0); 

			EnumChildWindows(hwnd, SetFontFunc, (LPARAM)Font);

			// Having created all other components, Instantiate a timer 
			// No timer id, 100 mS, force posting of a WM_TIMER message
			SetTimer(hwnd, 0, 100, NULL);
			
			// initialise displayed values in various controls
			
			// initialise Frequency Edit Box
			Frequency = GetFrequency(hRadio);
			SetDlgItemInt(hwnd, IDC_FREQEDIT, Frequency, FALSE);
									
			// initialise BFO UpDown control/ Edit Box
			BFOOffset = GetBFOOffset(hRadio);
			SendMessage(GetDlgItem(hwnd, IDC_BFO), UDM_SETPOS, 0, BFOOffset);

			// initialise Volume UpDown control/ Label
			SendMessage(GetDlgItem(hwnd, IDC_VOLUME), UDM_SETPOS, 0, Vol);
			
			// initialise Signal Level Progress Bar
			SignalStrength = GetSignalStrength(hRadio);
			SendMessage(GetDlgItem(hwnd, IDC_PROGRESSBAR), PBM_SETPOS, LOWORD(SignalStrength), 0);

			// initialise Mode Label
			Mode = GetMode(hRadio);
			ModeIndex = 0;
			while ((ModeIndex < RadioInfo.iNumModes) && 
				(Mode != RadioInfo.lpSupportedModes[ModeIndex])) 
				ModeIndex++;
			GetModeString(hRadio, Mode, ModeString, sizeof(ModeString));
			SetWindowText(GetDlgItem(hwnd, IDC_MODELABEL), ModeString);
			
			// set up BFO controls enable status depending on Mode.
			// SSB mode corresponds to Mode of 0 below:
			EnableWindow(GetDlgItem(hwnd, IDC_BFOEDIT), !(Mode & 0xFF));
			EnableWindow(GetDlgItem(hwnd, IDC_BFO), !(Mode & 0xFF));
			
			// initialise Attenuation Label
			Atten = GetAtten(hRadio);
			if (Atten) SetWindowText(GetDlgItem(hwnd, IDC_ATTENLABEL), "Local");
			else SetWindowText(GetDlgItem(hwnd, IDC_ATTENLABEL), "DX");

			// initialise Mute Label
			Mute = GetMute(hRadio);
			if (Mute) SetWindowText(GetDlgItem(hwnd, IDC_MUTELABEL), "ON");
			else SetWindowText(GetDlgItem(hwnd, IDC_MUTELABEL), "OFF");

			// initialise Power Label
			Power = GetPower(hRadio);
		    if (Power) SetWindowText(GetDlgItem(hwnd, IDC_POWERLABEL), "ON");
			else SetWindowText(GetDlgItem(hwnd, IDC_POWERLABEL), "OFF");

			return FALSE;

		case WM_CTLCOLORSTATIC:
			{
				LRESULT r;
				r = DefWindowProc(hwnd, uMsg, wParam, lParam);
				// set background colours for the controls
				if (GetDlgCtrlID((HWND)lParam) == IDC_HEADINGLABEL)
				{
					SetBkColor((HDC)wParam, RGB(0, 0xFF, 0));
					return r;
				}
				else
				{
					if (GetDlgCtrlID((HWND)lParam) < 0)
						return r;		
					SetBkColor((HDC)wParam, RGB(0xFF, 0xFF, 0xFF));
					return (LRESULT)GetStockObject(WHITE_BRUSH);
				}
				
			}
				
		case WM_DESTROY:	
			DeleteObject(Font);
			PostQuitMessage(0);
			return TRUE;

		case WM_COMMAND:	
			switch (LOWORD(wParam))
			{
				case IDC_ATTEN:
					Atten = !Atten;
					SetAtten(hRadio, Atten);
					if (Atten) SetWindowText(GetDlgItem(hwnd, IDC_ATTENLABEL), "Local");
					else SetWindowText(GetDlgItem(hwnd, IDC_ATTENLABEL), "DX");
					break;
				case IDC_MUTE:
					Mute = !Mute;
					SetMute(hRadio, Mute);
		    		if (Mute) SetWindowText(GetDlgItem(hwnd, IDC_MUTELABEL), "ON");
					else SetWindowText(GetDlgItem(hwnd, IDC_MUTELABEL), "OFF");
					break;
				case IDC_POWER:
					Power = !Power;
					SetPower(hRadio, Power);
		    		if (Power) SetWindowText(GetDlgItem(hwnd, IDC_POWERLABEL), "ON");
					else SetWindowText(GetDlgItem(hwnd, IDC_POWERLABEL), "OFF");
					break;
				case IDC_VOLUMEEDIT: 
					//get volume from the updown control udm
					if (HIWORD(wParam) == EN_CHANGE)
					{
						Volume = SendMessage(GetDlgItem(hwnd, IDC_VOLUME), UDM_GETPOS, 0, 0);
						SetVolume(hRadio, Volume);
					}
		    		break;
				case IDC_BFOEDIT: 
					//get BFO Offset from the updown control 
					if (HIWORD(wParam) == EN_CHANGE)
					{
						BFOOffset = SendMessage(GetDlgItem(hwnd, IDC_BFO), UDM_GETPOS, 0, 0);
						SetBFOOffset(hRadio, BFOOffset);
					}
		    		break;
				case IDC_FREQEDIT: 
				    //get Freq from the edit control 
					if (HIWORD(wParam) == EN_CHANGE)
					{
						Frequency = GetDlgItemInt(hwnd, IDC_FREQEDIT, NULL, FALSE);
						SetFrequency(hRadio, Frequency);
					}
		    		break;
				case IDC_MODE:
					ModeIndex = (ModeIndex + 1) % RadioInfo.iNumModes;
					Mode = RadioInfo.lpSupportedModes[ModeIndex];
					SetMode(hRadio, Mode);
					GetModeString(hRadio, LOBYTE(Mode), ModeString, sizeof(ModeString));
					SetWindowText(GetDlgItem(hwnd, IDC_MODELABEL), ModeString);
					
					// set up BFO controls enable status depending on Mode
					EnableWindow(GetDlgItem(hwnd, IDC_BFOEDIT), !(Mode & 0xFF));
					EnableWindow(GetDlgItem(hwnd, IDC_BFO), !(Mode & 0xFF));
					break;
				case IDC_QUIT:
					PostQuitMessage(0);
					break;
			}
			return TRUE;				

		case WM_TIMER:
			SignalStrength = GetSignalStrength(hRadio);
			SendMessage(GetDlgItem(hwnd, IDC_PROGRESSBAR), PBM_SETPOS, LOWORD(SignalStrength), 0);
			return FALSE;
		default: 
			return (DefWindowProc(hwnd, uMsg, wParam, lParam));
	}
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
			 LPSTR lpCmdLine, int nCmdShow)
{
	HWND MainWnd;
	WNDCLASS wc;
	MSG msg;

	hInst = hInstance;

	if (!LoadWRAPI()) return 255;

	hRadio = OpenRadioDevice(0);
	if (!hRadio) 
	{
		MessageBox(0, "Could not get a handle to the WiNRADiO card. If the WiNRADiO application is running, please terminate it and then re-run this program. This program will now terminate.", "WiNRADiO C++ API Demonstration", MB_OK | MB_ICONEXCLAMATION);
		return 255;
	}

	RadioInfo.dwSize = sizeof(RadioInfo);
	GetRadioDeviceInfo(hRadio, &RadioInfo);

	Atten = FALSE;
	Mute = FALSE;
	Power = TRUE;
	
	wc.style = CS_DBLCLKS;
	wc.lpfnWndProc = MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = 0; 
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName = 0; 
	wc.lpszClassName = "WiNRADiO_C_Demo_Class";

	// exit if class can not be created
	if (!RegisterClass(&wc)) return 255; 

	MainWnd = CreateWindowEx(0, "WiNRADiO_C_Demo_Class", "WiNRADiO API Demonstration", 
		WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE, 
		0, 0, 285, 187, 0, 0, hInstance, 0);

	// exit if window could not be created
	if (!MainWnd) return 255;	

	while (GetMessage(&msg, 0, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	CloseRadioDevice(hRadio);

	return msg.wParam;
	
}